"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrudFactory = void 0;
const cruds_1 = require("./cruds");
class CrudFactory {
    static databaseClientService(tableName, idColumnName, partitionKey = null) {
        var _a;
        const multiCloudDatabase = ((_a = process.env.RUNTIME_ENV) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === 'multi_platform';
        if (multiCloudDatabase)
            return new cruds_1.PostgreSqlCrudService(tableName, idColumnName, partitionKey);
        return new cruds_1.DynamoDbCrudService(tableName, idColumnName, partitionKey);
    }
}
exports.CrudFactory = CrudFactory;
//# sourceMappingURL=crud.service.js.map