"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgreSqlCrudService = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
const q_id_generator_1 = require("q-id-generator");
const postgreSqlClient_service_1 = __importDefault(require("./postgreSqlClient.service"));
class PostgreSqlCrudService extends postgreSqlClient_service_1.default {
    constructor(tableName, idColumnName = 'id', partitionKey = null) {
        super();
        this.tableName = tableName;
        this.idColumnName = idColumnName;
        this.partitionKey = partitionKey;
    }
    create(entity) {
        var _a;
        const id = ((_a = entity[this.idColumnName]) === null || _a === void 0 ? void 0 : _a.toString()) || (0, q_id_generator_1.getId)();
        const body = Object.assign(Object.assign({}, entity), { [this.idColumnName]: id });
        return this.createCommand(this.tableName, body).then((data) => data.rows[0]);
    }
    findById(findOptions) {
        return this.findCommand(this.tableName, findOptions).then((data) => (data === null || data === void 0 ? void 0 : data.length) ? data[0] : null);
    }
    find(findOptions) {
        const { pagination } = findOptions;
        return this.findCommand(this.tableName, findOptions).then((items) => {
            return { items, pagination };
        });
    }
    findAll(findOptions) {
        // eslint-disable-next-line no-unused-vars, @typescript-eslint/no-unused-vars
        const { pagination } = findOptions, findAllOptions = __rest(findOptions, ["pagination"]);
        return this.findCommand(this.tableName, findAllOptions).then((items) => {
            return { items, pagination: null };
        });
    }
    update(filters, data) {
        return this.updateCommand(this.tableName, filters, data);
    }
    async remove(filters) {
        await this.deleteCommand(this.tableName, filters);
    }
    runQuery(querySentence, values) {
        return super.executeQuery(querySentence, values);
    }
}
exports.PostgreSqlCrudService = PostgreSqlCrudService;
//# sourceMappingURL=postgreSqlCrud.service.js.map