"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable no-console */
const pg_1 = require("pg");
class QueryService {
    static getConnectionString() {
        return process.env.PG_CONNECTION_STRING || null;
    }
    static async openConnection() {
        if (QueryService.client)
            return;
        const connectionSettings = {};
        const connectionString = QueryService.getConnectionString();
        if (connectionString) {
            connectionSettings.connectionString = connectionString;
        }
        QueryService.client = new pg_1.Client(connectionSettings);
        return QueryService.client.connect().catch((error) => {
            console.log('[Postgresql-Client] Connection Failed:', error);
            throw error;
        });
    }
    static async executeQuery(queryText, values) {
        await QueryService.openConnection();
        if (!QueryService.client) {
            throw new Error('[Postgresql-Client] Connection not found.');
        }
        try {
            const result = await QueryService.client.query(queryText, values);
            return result;
        }
        catch (error) {
            console.log('[Postgresql-Client] Query Execution Failed:', error);
            throw error;
        }
    }
    static closeConnection() {
        if (QueryService.client) {
            QueryService.client.end();
        }
    }
}
QueryService.client = null;
exports.default = QueryService;
//# sourceMappingURL=query.service.js.map